package com.bpcl.lpg.core.dao.impl;

import de.hybris.platform.servicelayer.search.SearchResult;
import java.util.Collections;
import java.util.Objects;
import java.util.Map;
import de.hybris.platform.servicelayer.search.FlexibleSearchQuery;
import java.util.HashMap;
import java.util.List;
import com.bpcl.lpg.core.enums.GenericStatusEnum;
import java.util.Date;
import com.bpcl.lpg.core.dao.MechanicServiceRequestDao;
import com.bpcl.lpg.core.model.LpgMechanicSRModel;
import de.hybris.platform.servicelayer.internal.dao.DefaultGenericDao;

public class MechanicServiceRequestDaoImpl extends DefaultGenericDao<LpgMechanicSRModel> implements MechanicServiceRequestDao
{
    public MechanicServiceRequestDaoImpl(final String typecode) {
        super(typecode);
    }
    
    public List<LpgMechanicSRModel> getMechanicServiceRequestsByStatus(final Date startDate, final Date endDate, final GenericStatusEnum status) {
        final StringBuilder query = new StringBuilder("SELECT {msr.pk} from {").append("LpgMechanicSR").append(" as msr ").append("JOIN ").append("GenericStatusEnum").append(" as gse on {msr.").append("status").append("}={gse.pk}} ").append("WHERE {gse.code}=?").append("status").append(" AND {msr.").append("creationtime").append("}>= ?").append("startTime").append(" AND {msr.").append("creationtime").append("}<= ?").append("endTime");
        final Map<String, Object> param = new HashMap<String, Object>();
        param.put("status", status.getCode());
        param.put("startTime", startDate);
        param.put("endTime", endDate);
        final FlexibleSearchQuery flexibleSearchQuery = new FlexibleSearchQuery(query);
        flexibleSearchQuery.addQueryParameters((Map)param);
        final SearchResult<LpgMechanicSRModel> search = (SearchResult<LpgMechanicSRModel>)this.getFlexibleSearchService().search(flexibleSearchQuery);
        return Objects.isNull(search) ? Collections.emptyList() : search.getResult();
    }
}
